diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatInlines.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatInlines.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatInlines.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatInlines.h	2022-03-28 15:11:04.214708945 -0500
@@ -29,245 +29,13 @@
 #include "IntlNumberFormat.h"
 #include "IntlObjectInlines.h"
 #include "JSGlobalObject.h"
-#include "JSGlobalObjectFunctions.h"
 
 namespace JSC  {
 
-template<typename IntlType>
-void setNumberFormatDigitOptions(JSGlobalObject* globalObject, IntlType* intlInstance, JSObject* options, unsigned minimumFractionDigitsDefault, unsigned maximumFractionDigitsDefault, IntlNotation notation)
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    unsigned minimumIntegerDigits = intlNumberOption(globalObject, options, vm.propertyNames->minimumIntegerDigits, 1, 21, 1);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    JSValue minimumFractionDigitsValue = jsUndefined();
-    JSValue maximumFractionDigitsValue = jsUndefined();
-    JSValue minimumSignificantDigitsValue = jsUndefined();
-    JSValue maximumSignificantDigitsValue = jsUndefined();
-    if (options) {
-        minimumFractionDigitsValue = options->get(globalObject, vm.propertyNames->minimumFractionDigits);
-        RETURN_IF_EXCEPTION(scope, void());
-
-        maximumFractionDigitsValue = options->get(globalObject, vm.propertyNames->maximumFractionDigits);
-        RETURN_IF_EXCEPTION(scope, void());
-
-        minimumSignificantDigitsValue = options->get(globalObject, vm.propertyNames->minimumSignificantDigits);
-        RETURN_IF_EXCEPTION(scope, void());
-
-        maximumSignificantDigitsValue = options->get(globalObject, vm.propertyNames->maximumSignificantDigits);
-        RETURN_IF_EXCEPTION(scope, void());
-    }
-
-    intlInstance->m_minimumIntegerDigits = minimumIntegerDigits;
-
-    IntlRoundingPriority roundingPriority = intlOption<IntlRoundingPriority>(globalObject, options, vm.propertyNames->roundingPriority, { { "auto"_s, IntlRoundingPriority::Auto }, { "morePrecision"_s, IntlRoundingPriority::MorePrecision }, { "lessPrecision"_s, IntlRoundingPriority::LessPrecision } }, "roundingPriority must be either \"auto\", \"morePrecision\", or \"lessPrecision\""_s, IntlRoundingPriority::Auto);
-    RETURN_IF_EXCEPTION(scope, void());
-
-    bool hasSd = !minimumSignificantDigitsValue.isUndefined() || !maximumSignificantDigitsValue.isUndefined();
-    bool hasFd = !minimumFractionDigitsValue.isUndefined() || !maximumFractionDigitsValue.isUndefined();
-    bool needSd = hasSd || roundingPriority != IntlRoundingPriority::Auto;
-    bool needFd = (!hasSd && notation != IntlNotation::Compact) || roundingPriority != IntlRoundingPriority::Auto;
-
-    if (needSd) {
-        if (hasSd) {
-            unsigned minimumSignificantDigits = intlDefaultNumberOption(globalObject, minimumSignificantDigitsValue, vm.propertyNames->minimumSignificantDigits, 1, 21, 1);
-            RETURN_IF_EXCEPTION(scope, void());
-            unsigned maximumSignificantDigits = intlDefaultNumberOption(globalObject, maximumSignificantDigitsValue, vm.propertyNames->maximumSignificantDigits, minimumSignificantDigits, 21, 21);
-            RETURN_IF_EXCEPTION(scope, void());
-            intlInstance->m_minimumSignificantDigits = minimumSignificantDigits;
-            intlInstance->m_maximumSignificantDigits = maximumSignificantDigits;
-        } else {
-            intlInstance->m_minimumSignificantDigits = 1;
-            intlInstance->m_maximumSignificantDigits = 21;
-        }
-    }
-
-    if (needFd) {
-        if (hasFd) {
-            constexpr unsigned undefinedValue = UINT32_MAX;
-            unsigned minimumFractionDigits = intlDefaultNumberOption(globalObject, minimumFractionDigitsValue, vm.propertyNames->minimumFractionDigits, 0, 20, undefinedValue);
-            RETURN_IF_EXCEPTION(scope, void());
-            unsigned maximumFractionDigits = intlDefaultNumberOption(globalObject, maximumFractionDigitsValue, vm.propertyNames->maximumFractionDigits, 0, 20, undefinedValue);
-            RETURN_IF_EXCEPTION(scope, void());
-
-            if (minimumFractionDigits == undefinedValue)
-                minimumFractionDigits = std::min(minimumFractionDigitsDefault, maximumFractionDigits);
-            else if (maximumFractionDigits == undefinedValue)
-                maximumFractionDigits = std::max(maximumFractionDigitsDefault, minimumFractionDigits);
-            else if (minimumFractionDigits > maximumFractionDigits) {
-                throwRangeError(globalObject, scope, "Computed minimumFractionDigits is larger than maximumFractionDigits"_s);
-                return;
-            }
-
-            intlInstance->m_minimumFractionDigits = minimumFractionDigits;
-            intlInstance->m_maximumFractionDigits = maximumFractionDigits;
-        } else {
-            intlInstance->m_minimumFractionDigits = minimumFractionDigitsDefault;
-            intlInstance->m_maximumFractionDigits = maximumFractionDigitsDefault;
-        }
-    }
-
-    if (needSd || needFd) {
-        if (roundingPriority == IntlRoundingPriority::MorePrecision)
-            intlInstance->m_roundingType = IntlRoundingType::MorePrecision;
-        else if (roundingPriority == IntlRoundingPriority::LessPrecision)
-            intlInstance->m_roundingType = IntlRoundingType::LessPrecision;
-        else if (hasSd)
-            intlInstance->m_roundingType = IntlRoundingType::SignificantDigits;
-        else
-            intlInstance->m_roundingType = IntlRoundingType::FractionDigits;
-    } else {
-        intlInstance->m_roundingType = IntlRoundingType::MorePrecision;
-        intlInstance->m_minimumFractionDigits = 0;
-        intlInstance->m_maximumFractionDigits = 0;
-        intlInstance->m_minimumSignificantDigits = 1;
-        intlInstance->m_maximumSignificantDigits = 2;
-    }
-}
-
-template<typename IntlType>
-void appendNumberFormatDigitOptionsToSkeleton(IntlType* intlInstance, StringBuilder& skeletonBuilder)
-{
-    // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#integer-width
-    skeletonBuilder.append(" integer-width/", WTF::ICU::majorVersion() >= 67 ? '*' : '+'); // Prior to ICU 67, use the symbol + instead of *.
-    for (unsigned i = 0; i < intlInstance->m_minimumIntegerDigits; ++i)
-        skeletonBuilder.append('0');
-
-    if (intlInstance->m_roundingIncrement != 1) {
-        skeletonBuilder.append(" precision-increment/");
-        auto string = numberToStringUnsigned<Vector<LChar, 10>>(intlInstance->m_roundingIncrement);
-        if (intlInstance->m_maximumFractionDigits >= string.size()) {
-            skeletonBuilder.append("0.");
-            for (unsigned i = 0; i < (intlInstance->m_maximumFractionDigits - string.size()); ++i)
-                skeletonBuilder.append('0');
-            skeletonBuilder.appendCharacters(string.data(), string.size());
-        } else {
-            unsigned nonFraction = string.size() - intlInstance->m_maximumFractionDigits;
-            skeletonBuilder.appendCharacters(string.data(), nonFraction);
-            skeletonBuilder.append('.');
-            skeletonBuilder.appendCharacters(string.data() + nonFraction, intlInstance->m_maximumFractionDigits);
-        }
-    } else {
-        switch (intlInstance->m_roundingType) {
-        case IntlRoundingType::FractionDigits: {
-            // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#fraction-precision
-            skeletonBuilder.append(" .");
-            for (unsigned i = 0; i < intlInstance->m_minimumFractionDigits; ++i)
-                skeletonBuilder.append('0');
-            for (unsigned i = 0; i < intlInstance->m_maximumFractionDigits - intlInstance->m_minimumFractionDigits; ++i)
-                skeletonBuilder.append('#');
-            break;
-        }
-        case IntlRoundingType::SignificantDigits: {
-            // https://github.com/unicode-org/icu/blob/master/docs/userguide/format_parse/numbers/skeletons.md#significant-digits-precision
-            skeletonBuilder.append(' ');
-            for (unsigned i = 0; i < intlInstance->m_minimumSignificantDigits; ++i)
-                skeletonBuilder.append('@');
-            for (unsigned i = 0; i < intlInstance->m_maximumSignificantDigits - intlInstance->m_minimumSignificantDigits; ++i)
-                skeletonBuilder.append('#');
-            break;
-        }
-        case IntlRoundingType::MorePrecision:
-        case IntlRoundingType::LessPrecision:
-            // Before Intl.NumberFormat v3, it was CompactRounding mode, where we do not configure anything.
-            // So, if linked ICU is ~68, we do nothing.
-            if (WTF::ICU::majorVersion() >= 69) {
-                // https://github.com/unicode-org/icu/commit/d7db6c1f8655bb53153695b09a50029fd04a8364
-                // https://github.com/unicode-org/icu/blob/main/docs/userguide/format_parse/numbers/skeletons.md#precision
-                skeletonBuilder.append(" .");
-                for (unsigned i = 0; i < intlInstance->m_minimumFractionDigits; ++i)
-                    skeletonBuilder.append('0');
-                for (unsigned i = 0; i < intlInstance->m_maximumFractionDigits - intlInstance->m_minimumFractionDigits; ++i)
-                    skeletonBuilder.append('#');
-                skeletonBuilder.append('/');
-                for (unsigned i = 0; i < intlInstance->m_minimumSignificantDigits; ++i)
-                    skeletonBuilder.append('@');
-                for (unsigned i = 0; i < intlInstance->m_maximumSignificantDigits - intlInstance->m_minimumSignificantDigits; ++i)
-                    skeletonBuilder.append('#');
-                skeletonBuilder.append(intlInstance->m_roundingType == IntlRoundingType::MorePrecision ? 'r' : 's');
-            }
-            break;
-        }
-    }
-}
-
-class IntlFieldIterator {
-public:
-    WTF_MAKE_NONCOPYABLE(IntlFieldIterator);
-
-    explicit IntlFieldIterator(UFieldPositionIterator& iterator)
-        : m_iterator(iterator)
-    {
-    }
-
-    int32_t next(int32_t& beginIndex, int32_t& endIndex, UErrorCode&)
-    {
-        return ufieldpositer_next(&m_iterator, &beginIndex, &endIndex);
-    }
-
-private:
-    UFieldPositionIterator& m_iterator;
-};
-
 // https://tc39.es/ecma402/#sec-unwrapnumberformat
 inline IntlNumberFormat* IntlNumberFormat::unwrapForOldFunctions(JSGlobalObject* globalObject, JSValue thisValue)
 {
     return unwrapForLegacyIntlConstructor<IntlNumberFormat>(globalObject, thisValue, globalObject->numberFormatConstructor());
 }
 
-// https://tc39.es/proposal-intl-numberformat-v3/out/numberformat/diff.html#sec-tointlmathematicalvalue
-inline IntlMathematicalValue toIntlMathematicalValue(JSGlobalObject* globalObject, JSValue value)
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    if (auto number = JSBigInt::tryExtractDouble(value))
-        return IntlMathematicalValue { number.value() };
-
-    JSValue primitive = value.toPrimitive(globalObject, PreferredPrimitiveType::PreferNumber);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    auto bigIntToIntlMathematicalValue = [](JSGlobalObject* globalObject, JSValue value) -> IntlMathematicalValue {
-        VM& vm = globalObject->vm();
-        auto scope = DECLARE_THROW_SCOPE(vm);
-
-        if (auto number = JSBigInt::tryExtractDouble(value))
-            return IntlMathematicalValue { number.value() };
-
-        auto* bigInt = value.asHeapBigInt();
-        auto string = bigInt->toString(globalObject, 10);
-        RETURN_IF_EXCEPTION(scope, { });
-        return IntlMathematicalValue {
-            IntlMathematicalValue::NumberType::Integer,
-            bigInt->sign(),
-            string.ascii(),
-        };
-    };
-
-    if (primitive.isBigInt())
-        RELEASE_AND_RETURN(scope, bigIntToIntlMathematicalValue(globalObject, primitive));
-
-    if (!primitive.isString())
-        RELEASE_AND_RETURN(scope, IntlMathematicalValue { primitive.toNumber(globalObject) });
-
-    String string = asString(primitive)->value(globalObject);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    JSValue bigInt = JSBigInt::stringToBigInt(globalObject, string);
-    if (bigInt) {
-        // If it is -0, we cannot handle it in JSBigInt. Reparse the string as double.
-#if USE(BIGINT32)
-        if (bigInt.isBigInt32() && !value.bigInt32AsInt32())
-            return IntlMathematicalValue { jsToNumber(string) };
-#endif
-        if (bigInt.isHeapBigInt() && !asHeapBigInt(bigInt)->length())
-            return IntlMathematicalValue { jsToNumber(string) };
-        RELEASE_AND_RETURN(scope, bigIntToIntlMathematicalValue(globalObject, bigInt));
-    }
-
-    return IntlMathematicalValue { jsToNumber(string) };
-}
-
 } // namespace JSC
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.cpp	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.cpp	2022-03-28 15:11:04.214708945 -0500
@@ -28,25 +28,15 @@
 #include "IntlNumberFormatPrototype.h"
 
 #include "BuiltinNames.h"
-#include "IntlNumberFormatInlines.h"
 #include "JSBoundFunction.h"
 #include "JSCInlines.h"
 
 namespace JSC {
 
 static JSC_DECLARE_CUSTOM_GETTER(intlNumberFormatPrototypeGetterFormat);
-static JSC_DECLARE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatToParts);
 static JSC_DECLARE_HOST_FUNCTION(intlNumberFormatPrototypeFuncResolvedOptions);
 static JSC_DECLARE_HOST_FUNCTION(intlNumberFormatFuncFormat);
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-static JSC_DECLARE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatRange);
-#endif
-
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER_FORMAT_RANGE_TO_PARTS)
-static JSC_DECLARE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatRangeToParts);
-#endif
-
 }
 
 #include "IntlNumberFormatPrototype.lut.h"
@@ -58,15 +48,14 @@ const ClassInfo IntlNumberFormatPrototyp
 /* Source for IntlNumberFormatPrototype.lut.h
 @begin numberFormatPrototypeTable
   format           intlNumberFormatPrototypeGetterFormat         DontEnum|ReadOnly|CustomAccessor
-  formatToParts    intlNumberFormatPrototypeFuncFormatToParts    DontEnum|Function 1
   resolvedOptions  intlNumberFormatPrototypeFuncResolvedOptions  DontEnum|Function 0
 @end
 */
 
-IntlNumberFormatPrototype* IntlNumberFormatPrototype::create(VM& vm, JSGlobalObject* globalObject, Structure* structure)
+IntlNumberFormatPrototype* IntlNumberFormatPrototype::create(VM& vm, JSGlobalObject*, Structure* structure)
 {
     IntlNumberFormatPrototype* object = new (NotNull, allocateCell<IntlNumberFormatPrototype>(vm)) IntlNumberFormatPrototype(vm, structure);
-    object->finishCreation(vm, globalObject);
+    object->finishCreation(vm);
     return object;
 }
 
@@ -80,18 +69,11 @@ IntlNumberFormatPrototype::IntlNumberFor
 {
 }
 
-void IntlNumberFormatPrototype::finishCreation(VM& vm, JSGlobalObject* globalObject)
+void IntlNumberFormatPrototype::finishCreation(VM& vm)
 {
     Base::finishCreation(vm);
     ASSERT(inherits(vm, info()));
     JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
-    UNUSED_PARAM(globalObject);
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-    JSC_NATIVE_FUNCTION_WITHOUT_TRANSITION("formatRange", intlNumberFormatPrototypeFuncFormatRange, static_cast<unsigned>(PropertyAttribute::DontEnum), 2);
-#endif
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER_FORMAT_RANGE_TO_PARTS)
-    JSC_NATIVE_FUNCTION_WITHOUT_TRANSITION("formatRangeToParts", intlNumberFormatPrototypeFuncFormatRangeToParts, static_cast<unsigned>(PropertyAttribute::DontEnum), 2);
-#endif
 }
 
 // https://tc39.es/ecma402/#sec-number-format-functions
@@ -101,13 +83,26 @@ JSC_DEFINE_HOST_FUNCTION(intlNumberForma
     auto scope = DECLARE_THROW_SCOPE(vm);
     auto* numberFormat = jsCast<IntlNumberFormat*>(callFrame->thisValue());
 
-    auto value = toIntlMathematicalValue(globalObject, callFrame->argument(0));
-    RETURN_IF_EXCEPTION(scope, { });
+    JSValue bigIntOrNumber = callFrame->argument(0).toNumeric(globalObject);
+    RETURN_IF_EXCEPTION(scope, encodedJSValue());
 
-    if (auto number = value.tryGetDouble())
-        RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->format(globalObject, number.value())));
+    scope.release();
+    if (bigIntOrNumber.isNumber()) {
+        double value = bigIntOrNumber.asNumber();
+        return JSValue::encode(numberFormat->format(globalObject, value));
+    }
+
+#if USE(BIGINT32)
+    if (bigIntOrNumber.isBigInt32()) {
+        JSBigInt* value = JSBigInt::createFrom(globalObject, bigIntOrNumber.bigInt32AsInt32());
+        RETURN_IF_EXCEPTION(scope, { });
+        RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->format(globalObject, value)));
+    }
+#endif
 
-    RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->format(globalObject, WTFMove(value))));
+    ASSERT(bigIntOrNumber.isHeapBigInt());
+    JSBigInt* value = bigIntOrNumber.asHeapBigInt();
+    return JSValue::encode(numberFormat->format(globalObject, value));
 }
 
 JSC_DEFINE_CUSTOM_GETTER(intlNumberFormatPrototypeGetterFormat, (JSGlobalObject* globalObject, EncodedJSValue thisValue, PropertyName))
@@ -139,38 +134,7 @@ JSC_DEFINE_CUSTOM_GETTER(intlNumberForma
     return JSValue::encode(boundFormat);
 }
 
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER)
-JSC_DEFINE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatRange, (JSGlobalObject* globalObject, CallFrame* callFrame))
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    // Do not use unwrapForOldFunctions.
-    auto* numberFormat = jsDynamicCast<IntlNumberFormat*>(vm, callFrame->thisValue());
-    if (UNLIKELY(!numberFormat))
-        return JSValue::encode(throwTypeError(globalObject, scope, "Intl.NumberFormat.prototype.formatRange called on value that's not a NumberFormat"_s));
-
-    JSValue startValue = callFrame->argument(0);
-    JSValue endValue = callFrame->argument(1);
-
-    if (startValue.isUndefined() || endValue.isUndefined())
-        return throwVMTypeError(globalObject, scope, "start or end is undefined"_s);
-
-    auto start = toIntlMathematicalValue(globalObject, startValue);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    auto end = toIntlMathematicalValue(globalObject, endValue);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    if (auto startNumber = start.tryGetDouble()) {
-        if (auto endNumber = end.tryGetDouble())
-            RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatRange(globalObject, startNumber.value(), endNumber.value())));
-    }
-
-    RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatRange(globalObject, WTFMove(start), WTFMove(end))));
-}
-#endif
-
+#if 0
 JSC_DEFINE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatToParts, (JSGlobalObject* globalObject, CallFrame* callFrame))
 {
     VM& vm = globalObject->vm();
@@ -184,51 +148,10 @@ JSC_DEFINE_HOST_FUNCTION(intlNumberForma
     if (UNLIKELY(!numberFormat))
         return JSValue::encode(throwTypeError(globalObject, scope, "Intl.NumberFormat.prototype.formatToParts called on value that's not a NumberFormat"_s));
 
-#if HAVE(ICU_U_NUMBER_FORMATTER)
-    auto value = toIntlMathematicalValue(globalObject, callFrame->argument(0));
-    RETURN_IF_EXCEPTION(scope, { });
-
-    if (auto number = value.tryGetDouble())
-        RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatToParts(globalObject, number.value())));
-
-    RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatToParts(globalObject, WTFMove(value))));
-#else
     double value = callFrame->argument(0).toNumber(globalObject);
-    RETURN_IF_EXCEPTION(scope, { });
+    RETURN_IF_EXCEPTION(scope, encodedJSValue());
 
     RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatToParts(globalObject, value)));
-#endif
-}
-
-#if HAVE(ICU_U_NUMBER_RANGE_FORMATTER_FORMAT_RANGE_TO_PARTS)
-JSC_DEFINE_HOST_FUNCTION(intlNumberFormatPrototypeFuncFormatRangeToParts, (JSGlobalObject* globalObject, CallFrame* callFrame))
-{
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    // Do not use unwrapForOldFunctions.
-    auto* numberFormat = jsDynamicCast<IntlNumberFormat*>(vm, callFrame->thisValue());
-    if (UNLIKELY(!numberFormat))
-        return JSValue::encode(throwTypeError(globalObject, scope, "Intl.NumberFormat.prototype.formatRangeToParts called on value that's not a NumberFormat"_s));
-
-    JSValue startValue = callFrame->argument(0);
-    JSValue endValue = callFrame->argument(1);
-
-    if (startValue.isUndefined() || endValue.isUndefined())
-        return throwVMTypeError(globalObject, scope, "start or end is undefined"_s);
-
-    auto start = toIntlMathematicalValue(globalObject, startValue);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    auto end = toIntlMathematicalValue(globalObject, endValue);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    if (auto startNumber = start.tryGetDouble()) {
-        if (auto endNumber = end.tryGetDouble())
-            RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatRangeToParts(globalObject, startNumber.value(), endNumber.value())));
-    }
-
-    RELEASE_AND_RETURN(scope, JSValue::encode(numberFormat->formatRangeToParts(globalObject, WTFMove(start), WTFMove(end))));
 }
 #endif
 
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlNumberFormatPrototype.h	2022-03-28 15:11:04.218708967 -0500
@@ -49,7 +49,7 @@ public:
 
 private:
     IntlNumberFormatPrototype(VM&, Structure*);
-    void finishCreation(VM&, JSGlobalObject*);
+    void finishCreation(VM&);
 };
 
 } // namespace JSC
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObject.cpp webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObject.cpp
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObject.cpp	2022-03-29 15:02:28.892121597 -0500
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObject.cpp	2022-03-28 15:11:04.218708967 -0500
@@ -39,19 +39,11 @@
 #include "IntlDisplayNames.h"
 #include "IntlDisplayNamesConstructor.h"
 #include "IntlDisplayNamesPrototype.h"
-#include "IntlListFormat.h"
-#include "IntlListFormatConstructor.h"
-#include "IntlListFormatPrototype.h"
-#include "IntlLocale.h"
-#include "IntlLocaleConstructor.h"
-#include "IntlLocalePrototype.h"
 #include "IntlNumberFormatConstructor.h"
 #include "IntlNumberFormatPrototype.h"
 #include "IntlObjectInlines.h"
 #include "IntlPluralRulesConstructor.h"
 #include "IntlPluralRulesPrototype.h"
-#include "IntlRelativeTimeFormatConstructor.h"
-#include "IntlRelativeTimeFormatPrototype.h"
 #include "IntlSegmenter.h"
 #include "IntlSegmenterConstructor.h"
 #include "IntlSegmenterPrototype.h"
@@ -61,7 +53,6 @@
 #include <unicode/ucal.h>
 #include <unicode/ucol.h>
 #include <unicode/ucurr.h>
-#include <unicode/ufieldpositer.h>
 #include <unicode/uloc.h>
 #include <unicode/unumsys.h>
 #include <wtf/Assertions.h>
@@ -100,20 +91,6 @@ static JSValue createDisplayNamesConstru
     return IntlDisplayNamesConstructor::create(vm, IntlDisplayNamesConstructor::createStructure(vm, globalObject, globalObject->functionPrototype()), jsCast<IntlDisplayNamesPrototype*>(globalObject->displayNamesStructure()->storedPrototypeObject()));
 }
 
-static JSValue createListFormatConstructor(VM& vm, JSObject* object)
-{
-    IntlObject* intlObject = jsCast<IntlObject*>(object);
-    JSGlobalObject* globalObject = intlObject->globalObject(vm);
-    return IntlListFormatConstructor::create(vm, IntlListFormatConstructor::createStructure(vm, globalObject, globalObject->functionPrototype()), jsCast<IntlListFormatPrototype*>(globalObject->listFormatStructure()->storedPrototypeObject()));
-}
-
-static JSValue createLocaleConstructor(VM& vm, JSObject* object)
-{
-    IntlObject* intlObject = jsCast<IntlObject*>(object);
-    JSGlobalObject* globalObject = intlObject->globalObject(vm);
-    return IntlLocaleConstructor::create(vm, IntlLocaleConstructor::createStructure(vm, globalObject, globalObject->functionPrototype()), jsCast<IntlLocalePrototype*>(globalObject->localeStructure()->storedPrototypeObject()));
-}
-
 static JSValue createNumberFormatConstructor(VM& vm, JSObject* object)
 {
     IntlObject* intlObject = jsCast<IntlObject*>(object);
@@ -128,13 +105,6 @@ static JSValue createPluralRulesConstruc
     return IntlPluralRulesConstructor::create(vm, IntlPluralRulesConstructor::createStructure(vm, globalObject, globalObject->functionPrototype()), jsCast<IntlPluralRulesPrototype*>(globalObject->pluralRulesStructure()->storedPrototypeObject()));
 }
 
-static JSValue createRelativeTimeFormatConstructor(VM& vm, JSObject* object)
-{
-    IntlObject* intlObject = jsCast<IntlObject*>(object);
-    JSGlobalObject* globalObject = intlObject->globalObject(vm);
-    return IntlRelativeTimeFormatConstructor::create(vm, IntlRelativeTimeFormatConstructor::createStructure(vm, globalObject, globalObject->functionPrototype()), jsCast<IntlRelativeTimeFormatPrototype*>(globalObject->relativeTimeFormatStructure()->storedPrototypeObject()));
-}
-
 static JSValue createSegmenterConstructor(VM& vm, JSObject* object)
 {
     IntlObject* intlObject = jsCast<IntlObject*>(object);
@@ -154,10 +124,8 @@ namespace JSC {
   Collator              createCollatorConstructor                    DontEnum|PropertyCallback
   DateTimeFormat        createDateTimeFormatConstructor              DontEnum|PropertyCallback
   DisplayNames          createDisplayNamesConstructor                DontEnum|PropertyCallback
-  Locale                createLocaleConstructor                      DontEnum|PropertyCallback
   NumberFormat          createNumberFormatConstructor                DontEnum|PropertyCallback
   PluralRules           createPluralRulesConstructor                 DontEnum|PropertyCallback
-  RelativeTimeFormat    createRelativeTimeFormatConstructor          DontEnum|PropertyCallback
   Segmenter             createSegmenterConstructor                   DontEnum|PropertyCallback
 @end
 */
@@ -170,11 +138,13 @@ struct MatcherResult {
 
 const ClassInfo IntlObject::s_info = { "Intl", &Base::s_info, &intlObjectTable, nullptr, CREATE_METHOD_TABLE(IntlObject) };
 
+#if 0
 void UFieldPositionIteratorDeleter::operator()(UFieldPositionIterator* iterator) const
 {
     if (iterator)
         ufieldpositer_close(iterator);
 }
+#endif
 
 const MeasureUnit simpleUnits[43] = {
     { "area"_s, "acre"_s },
@@ -239,11 +209,6 @@ void IntlObject::finishCreation(VM& vm,
     Base::finishCreation(vm);
     ASSERT(inherits(vm, info()));
     JSC_TO_STRING_TAG_WITHOUT_TRANSITION();
-#if HAVE(ICU_U_LIST_FORMATTER)
-    putDirectWithoutTransition(vm, vm.propertyNames->ListFormat, createListFormatConstructor(vm, this), static_cast<unsigned>(PropertyAttribute::DontEnum));
-#else
-    UNUSED_PARAM(&createListFormatConstructor);
-#endif
     if (Options::useIntlEnumeration())
         JSC_NATIVE_FUNCTION_WITHOUT_TRANSITION("supportedValuesOf", intlObjectFuncSupportedValuesOf, static_cast<unsigned>(PropertyAttribute::DontEnum), 1);
 }
@@ -702,7 +667,7 @@ Vector<String> canonicalizeLocaleList(JS
         return seen;
 
     JSObject* localesObject;
-    if (locales.isString() || locales.inherits<IntlLocale>(vm)) {
+    if (locales.isString()) {
         JSArray* localesArray = JSArray::tryCreate(vm, globalObject->arrayStructureForIndexingTypeDuringAllocation(ArrayWithContiguous));
         if (!localesArray) {
             throwOutOfMemoryError(globalObject, scope);
@@ -739,15 +704,12 @@ Vector<String> canonicalizeLocaleList(JS
             }
 
             String tag;
-            if (kValue.inherits<IntlLocale>(vm))
-                tag = jsCast<IntlLocale*>(kValue)->toString();
-            else {
-                JSString* string = kValue.toString(globalObject);
-                RETURN_IF_EXCEPTION(scope, Vector<String>());
+            JSString* string = kValue.toString(globalObject);
+            RETURN_IF_EXCEPTION(scope, Vector<String>());
 
-                tag = string->value(globalObject);
-                RETURN_IF_EXCEPTION(scope, Vector<String>());
-            }
+            tag = string->value(globalObject);
+        RETURN_IF_EXCEPTION(scope, Vector<String>());
+ 
 
             if (isStructurallyValidLanguageTag(tag)) {
                 ASSERT(tag.isAllASCII());
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObject.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObject.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObject.h	2022-03-29 15:02:28.892121597 -0500
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObject.h	2022-03-28 15:11:04.218708967 -0500
@@ -99,7 +99,6 @@ inline const LocaleSet& intlDisplayNames
 inline const LocaleSet& intlNumberFormatAvailableLocales() { return intlAvailableLocales(); }
 inline const LocaleSet& intlPluralRulesAvailableLocales() { return intlAvailableLocales(); }
 inline const LocaleSet& intlRelativeTimeFormatAvailableLocales() { return intlAvailableLocales(); }
-inline const LocaleSet& intlListFormatAvailableLocales() { return intlAvailableLocales(); }
 
 using CalendarID = unsigned;
 const Vector<String>& intlAvailableCalendars();
diff -urp webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObjectInlines.h webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObjectInlines.h
--- webkitgtk-2.36.0.icu60/Source/JavaScriptCore/runtime/IntlObjectInlines.h	2022-02-23 02:58:53.000000000 -0600
+++ webkitgtk-2.36.0.icu52/Source/JavaScriptCore/runtime/IntlObjectInlines.h	2022-03-28 15:11:04.218708967 -0500
@@ -151,45 +151,6 @@ ResultType intlOption(JSGlobalObject* gl
     return fallback;
 }
 
-template<typename ResultType>
-ResultType intlStringOrBooleanOption(JSGlobalObject* globalObject, JSObject* options, PropertyName property, ResultType trueValue, ResultType falsyValue, std::initializer_list<std::pair<ASCIILiteral, ResultType>> values, ASCIILiteral notFoundMessage, ResultType fallback)
-{
-    // https://tc39.es/proposal-intl-numberformat-v3/out/negotiation/diff.html#sec-getstringorbooleanoption
-
-    ASSERT(values.size() > 0);
-
-    VM& vm = globalObject->vm();
-    auto scope = DECLARE_THROW_SCOPE(vm);
-
-    if (!options)
-        return fallback;
-
-    JSValue value = options->get(globalObject, property);
-    RETURN_IF_EXCEPTION(scope, { });
-
-    if (!value.isUndefined()) {
-        if (value.isBoolean() && value.asBoolean())
-            return trueValue;
-
-        bool valueBoolean = value.toBoolean(globalObject);
-        RETURN_IF_EXCEPTION(scope, { });
-
-        if (!valueBoolean)
-            return falsyValue;
-
-        String stringValue = value.toWTFString(globalObject);
-        RETURN_IF_EXCEPTION(scope, { });
-
-        for (const auto& entry : values) {
-            if (entry.first == stringValue)
-                return entry.second;
-        }
-        throwException(globalObject, scope, createRangeError(globalObject, notFoundMessage));
-        return { };
-    }
-
-    return fallback;
-}
 
 ALWAYS_INLINE bool canUseASCIIUCADUCETComparison(UChar character)
 {
